#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_LoadResourceCFG.h"
std::auto_ptr<Fish_LoadResourceCFG> Fish_LoadResourceCFG::msSingleton(nullptr);

int Fish_LoadResourceCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_LoadResourceCFGData* Fish_LoadResourceCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_LoadResourceCFGData>& Fish_LoadResourceCFG::GetMapData()
{
	return mMapData;
}

void Fish_LoadResourceCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_LoadResourceCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_LoadResourceCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mResType = element->IntAttribute("ResType");
		data.mResPath = element->Attribute("ResPath");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_LoadResourceCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_LoadResourceCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_LoadResourceCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_LoadResourceCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_LoadResourceCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "ResType", data.mResType);
		LuaCfgHelper::readString(L, "ResPath", data.mResPath);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_LoadResourceCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_LoadResourceCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_LoadResourceCFG* Fish_LoadResourceCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_LoadResourceCFG());
	}
	return msSingleton.get();
}

void Fish_LoadResourceCFG::Release()
{
	msSingleton.reset(nullptr);
}
